# $Id: swup.spec,v 1.19 2004/03/15 09:47:41 christht Exp $
Summary: The secure software updater
Name: swup
Version: 2.3.17
Release: 6tr
License: GPL
Group: Trustix Official
Source0: %{name}-%{version}.tar.bz2
Patch0: swup-2.3.17-multiproviders-fix.patch
Patch1: rdfgen-encoding.patch
ExclusiveOs: Linux
Requires: rpm, rpm-python, gnupg, swupconf, sysklogd
PreReq: python >= 1.5.2
Requires: %{name}-libs = %{version}
Requires: tsl-gpgkeys
BuildRoot: %{_tmppath}/%{name}-root
BuildArch: noarch
Provides: softwareupdater
BuildRequires: python, coreutils
%define sitepackagedir usr/lib/python$(python -V 2>&1| cut -c8-10)

%description
SWUP - SoftWare UPdater is an extension for existing software packaging
systems to facilitate automatic and secure update and install. SWUP
handles dependencies between software packages, and is able to fetch
additional required software when installing or upgrading.

%package libs
Summary: Swup libraries shared with rdfgen
Group: Trustix Official
PreReq: python >= 1.5.2

%description libs
Swup libs shared by swup and rdfgen

%package -n rdfgen
Summary: Resource Description Framework GENerator
Group: Trustix Official
Requires: %{name}-libs = %{version}
PreReq: python >= 1.5.2

%description -n rdfgen
Generates database files in rdf/xml format to work with the swup software
upgrading tool.

%package -n swupconf
Summary: Config file for swup.
Group: Trustix Official

%description -n swupconf
This is the configuration file for swup. You can't have one without the other.

%package -n swupcron
Summary: Cron file for swup.
Group: Trustix Official
Requires: crond

%description -n swupcron
This is the cron file for swup. Install this if you want swup to be run
automatically.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}/var/log/swup
make
make DESTDIR=${RPM_BUILD_ROOT} install
install -d -m 0755 ${RPM_BUILD_ROOT}/usr/bin
for f in `find ${RPM_BUILD_ROOT}/usr/lib/swup -name \*.py`; do
    touch ${f}c
done
for f in `find ${RPM_BUILD_ROOT}/%{sitepackagedir} -name \*.py`; do
    touch ${f}c
done
for i in ${RPM_BUILD_ROOT}/var/log/swup/{info,errors,warnings}; do
   touch $i
done
# rdf ghost files, must be removed when uninstalling this package.
for i in rdf rdfgen; do
	touch ${RPM_BUILD_ROOT}/usr/lib/rdfgen/$i.pyc
done

#swupconf
mkdir -p ${RPM_BUILD_ROOT}/etc/swup/{gnupg,samples}
touch ${RPM_BUILD_ROOT}/etc/swup/gnupg/pubring.gpg

#
# Pick suitable config:
#
install -m 0644 etc/swup/swup.conf-* ${RPM_BUILD_ROOT}/etc/swup/samples/
if [ -f  etc/swup/swup.conf-%{?release_version} ]; then
    install -m 0644 etc/swup/swup.conf-%{?release_version} \
        ${RPM_BUILD_ROOT}/etc/swup/swup.conf
else
    echo ""
    echo "No nice config found, installing /etc/swup/swup.conf"
    echo ""
    sleep 3
    install -m 0644 etc/swup/swup.conf-default \
        ${RPM_BUILD_ROOT}/etc/swup/swup.conf
fi
#swupcron
mkdir -p ${RPM_BUILD_ROOT}/etc/cron.{hourly,daily,weekly,monthly}/
install -m 0755 etc/cron.daily/swup.cron \
    ${RPM_BUILD_ROOT}/etc/cron.daily/swup.cron
touch ${RPM_BUILD_ROOT}/etc/cron.{hourly,weekly,monthly}/swup.cron

#
# Generate site package filelist
#
pushd $RPM_BUILD_ROOT
for file in `find %{sitepackagedir} -name \*.py`; do
	echo /${file} 
	echo %ghost /${file}c 
done >> ${RPM_BUILD_DIR}/%{name}-%{version}/sitefiles.txt
popd

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf ${RPM_BUILD_ROOT}

%post
python -c "import compileall; compileall.compile_dir('/usr/lib/swup')" \
	> /dev/null 2>&1

%post -n rdfgen
python -c "import compileall; compileall.compile_dir('/usr/lib/rdfgen')" \
	> /dev/null 2>&1

%post libs
python -c "import compileall; compileall.compile_dir('/%{sitepackagedir}')" \
	> /dev/null 2>&1

%files
%defattr(-,root,root)
%doc docs/README docs/COPYING docs/CHANGELOG
%doc docs/swup.vimrc
/usr/bin/swup
%dir /usr/lib/swup
/usr/lib/swup/*.py
/usr/share/man/man1/swup.1.gz
/usr/share/man/man5/swup.5.gz
%ghost /usr/lib/swup/*.pyc

%files libs -f sitefiles.txt

%files -n rdfgen
%defattr(-,root,root)
/usr/bin/rdfgen
%dir /usr/lib/rdfgen
/usr/lib/rdfgen/*.py
/usr/share/man/man1/rdfgen.*
%ghost /usr/lib/rdfgen/*.pyc

%files -n swupcron
%defattr(0755,root,root)
/etc/cron.daily/swup.cron
%ghost /etc/cron.hourly/swup.cron
%ghost /etc/cron.monthly/swup.cron
%ghost /etc/cron.weekly/swup.cron

%files -n swupconf
%defattr(0755,root,root)
%config(noreplace) /etc/swup/swup.conf
/etc/swup/samples
%dir %attr(0700,root,root) /etc/swup/gnupg
%config(noreplace) /etc/swup/gnupg/pubring.gpg

%changelog
* Wed Sep  8 2004 Chr. H. Toldnes <christht at trustix dot org> 2.3.17-6tr
- Be silent about python compilation

* Wed Sep  8 2004 Chr. H. Toldnes <christht at trustix dot org> 2.3.17-5tr
- Added patch to fix missing encoding specification in rdfs

* Wed Jun 23 2004 Chr. H. Toldnes <christht at trustix dot org> 2.3.17-4tr
- Added patch for multiproviders issue

* Thu Feb 26 2004 Chr. H. Toldnes <christht at trustix dot org> 1ct
- Changelog now for specfile only
- Intelligent finding correct config.
